###
# No Copyright 2008, fv
# No rights reserved.
#
#
###

import supybot.utils as utils
from supybot.commands import *
import supybot.plugins as plugins
import supybot.ircutils as ircutils
import supybot.callbacks as callbacks

import popen2


class FreejBot(callbacks.Plugin):
	"""launches freej javascript commands"""
	
	def __init__(self, irc):
		self.__parent = super(FreejBot, self)
		self.__parent.__init__(irc)
		
		# flag to set if script shall run as test-only or live with freej
		self.TESTF = True
		
		
		# config
		self.freejbin = "/usr/local/bin/freej"
		self.freejargs = "-j"
		self.javascriptdir = "/home/"
		# map irc commands to freej js files
		self.irc_freej = {"videoright" : "right.js", "videoleft" : "left.js"}
		
		
		# test config
		if self.TESTF == True:
			self.freejbin = "/bin/cat"
			self.freejargs = "-n"
			self.javascriptdir = "/home/transmediale08/Desktop/bots/freejbot/testfiles/"
			# map irc commands to freej js files
			self.irc_freej = {"videoright" : "right.txt", "videoleft" : "left.txt"}
	
	
	
	def DoCommand(self, irc, direction):
		"""takes no arguments

		Translates irc command to launch freej javascript files."""
		
		# check irc command: translation to artbus commands possible?
		if self.irc_freej.has_key(direction) == False:
			e = "unknown command. use one of these: " + str(self.irc_freej.keys())
			irc.error(e)
			return
		
		jsfile = self.irc_freej[direction]
		irc.reply("received command: " + direction)
		irc.reply("gonna try to tell freej to "+direction+" now...")
		
		# launch file
		print self.freejbin+" "+self.javascriptdir+jsfile
		inst = popen2.Popen4([self.freejbin, self.freejargs, self.javascriptdir+jsfile])
		(r, w) = (inst.fromchild, inst.tochild)
		try:
			lines = r.readlines()
			lines = map(str.rstrip, lines)
			lines = filter(None, lines)
			if lines:
				irc.replies(lines, joiner=' ')
			else:
				irc.error("error: couldn't launch freej js file")
			"""
			response = utils.str.normalizeWhitespace(r.readline().strip())
			if response:
				irc.reply(response)
				# reply success
				#irc.replySuccess()
			else:
				irc.error("error: couldn't launch freej js file")
			"""
		finally:
			r.close()
			w.close()
			inst.wait()
	
	
	
	def videoright(self, irc, msg, args):
		"""takes no arguments

		Moves somethin freej to the right. hehe."""
		self.DoCommand(irc, "videoright")	
	videoright = wrap(videoright)
	
	def videoleft(self, irc, msg, args):
		"""takes no arguments

		Moves somethin freej to the left. hehe."""
		self.DoCommand(irc, "videoleft")	
	videoleft = wrap(videoleft)
	
	
	pass


Class = FreejBot


# vim:set shiftwidth=4 tabstop=4 expandtab textwidth=79:
