#! /usr/bin/python

import serial #import serial library
import sys, time


# sequence of patterns, each for 4 pins
# (adapt to your needs)


#http://en.nanotec.com/steppermotor_animation.html
# !Zz; resets all to see that is there
patterns = ((0, 0, 0, 0), (0, 0, 0, 0))

# artbus command prefixes
command = ('j', 'k') # j = low(0), k = high (1)

# serial config
ser = serial.Serial() # instanciate serial class as ser
ser.port = '/dev/ttyUSB0' #  connection device
ser.baudrate = 115200 # sets the speed
ser.timeout = 0.1 # to not occupy the line forever

# open serial connection
try:
       ser.open() # opens serial port
except serial.SerialException, e:
       print e # prints an error if it doesn't work

# create artbus_commands...

for sequence in patterns: # iterate over `patterns`...


       for bit_number in range(len(sequence)): #...names pins and use each `tuple`
               bit = sequence[bit_number]
               cmnd = command[bit]
               artbus_command = '!S' + str(cmnd) + str(bit_number+1) + ';'
               # print and send artbus_command to serial connection
               print artbus_command
               ser.write(artbus_command) # !-bang J-analog board z-reset & semi-end_command
               # read & print response
               response = ser.readline() # reads the serial buffer
               print response
               # sleep a while
               time.sleep(0.5)
       print ""        # next sequence of patterns


# close serial connection
ser.close()



'''
For this script these is the command in the python console:
sh-3.2# python fabian2.py

--

will create an output like:

!Sk0;
!Sj1;
!Sj2;
!Sj3;

!Sj0;
!Sk1;
!Sj2;
!Sj3;

!Sj0;
!Sj1;
!Sk2;
!Sj3;

!Sj0;
!Sj1;
!Sj2;
!Sk3;

'''
